# endersgame ![tests](https://github.com/microprediction/endersgame/actions/workflows/tests.yml/badge.svg)

Utilities to help build `Attackers` that detect small departures from martingality in time-series. 

### About
This package is intended to make life simpler for those participating in an ongoing tournament at [CrunchDAO.com](https://www.crunchdao.com), although it hopefully has independent interest. For instance, you might build on `Attacker` or examples herein to help find signal in your model residuals.  

 - Colab [notebooks](https://github.com/microprediction/endersnotebooks) demonstrating `Attacker`.
 - See the README in [attacker.md](https://github.com/microprediction/endersgame/blob/main/endersgame/attackers/attacker.md).  
 - It's also highly recommended to read the [FAQ.md](https://github.com/microprediction/endersgame/blob/main/endersgame/attackers/FAQ.md).


### Install 
Stable:

     pip install endersgame 

Latest:

     pip install git+https://github.com/microprediction/endersgame.git
 
### Contest 

Play the game! You might win some cash or even have ongoing upside. 

| Contest notebook | Description |
| --- | --- |
| [Mean reversion](https://github.com/crunchdao/quickstarters/blob/master/competitions/mid-one/mean_reversion/mean_reversion.ipynb) | A minimalist contest entry notebook |
| [Mean reversion attacker](https://github.com/microprediction/quickstarters/blob/master/competitions/mid-one/mean_reversion_attacker/mean_reversion_attacker.ipynb) | Illustrates use of the `Attacker` class|
| [Momentum attacker](https://github.com/microprediction/quickstarters/blob/master/competitions/mid-one/momentum_attacker/momentum_attacker.ipynb) | Illustrates use of running calculations |
| [Regression Attacker](https://github.com/microprediction/quickstarters/blob/master/competitions/mid-one/regression_attacker/regression_attacker.ipynb) | Illustrates running regression pattern |


See the  [discord channel](https://discord.gg/NuqJTcYQ2J) and [CrunchDAO.com](https://www.crunchdao.com). 


